<?php
declare(ticks=1); 

class DaemonClass {
    // Максимальное количество дочерних процессов
    public $maxProcesses = 1;
    // Когда установится в TRUE, демон завершит работу
    protected $stop_server = FALSE;
    // Здесь будем хранить запущенные дочерние процессы
    protected $currentJobs = array();
    public $second = 0;
    public function __construct() {
        echo "Сonstructed daemon controller".PHP_EOL;
        // Ждем сигналы SIGTERM и SIGCHLD
        pcntl_signal(SIGTERM, array($this, "childSignalHandler"));
        pcntl_signal(SIGCHLD, array($this, "childSignalHandler"));
    }

    public function run() {
        echo "Running daemon controller".PHP_EOL;
        file_put_contents('/tmp/daemon.pid',getmypid());

        // Пока $stop_server не установится в TRUE, гоняем бесконечный цикл
        while (!$this->stop_server) {
            // Если уже запущено максимальное количество дочерних процессов, ждем их завершения
            while(count($this->currentJobs) >= $this->maxProcesses) {
                 sleep(1);
            }
            $this->second++;
            if(!file_exists(dirname(__FILE__) . '/../log/copy.pid')) $this->launchJob();
        }
    }
    protected function launchJob() { 
        // Создаем дочерний процесс
        // весь код после pcntl_fork() будет выполняться
        // двумя процессами: родительским и дочерним
        $pid = pcntl_fork();
        if ($pid == -1){
            // Не удалось создать дочерний процесс
            error_log('Could not launch new job, exiting');
            return FALSE;
        } 
        elseif ($pid) {
            // Этот код выполнится родительским процессом
            if($this->second >= 40){
                $this->second = 0;
            }
            $this->currentJobs[$pid] = TRUE;
        }
        else {
            echo "Проверка доступности сервера " . $this->second . PHP_EOL;
            if($this->second >= 40){
                if(!file_exists(dirname(__FILE__) . '/../log/copy.pid')){
                    ob_start();
                    echo "Синхронизация файлов " . PHP_EOL;
                    system("/usr/bin/flock -w 0 -x /home/sutra/lock.lock /usr/bin/rsync -avz root@8.8.8.8:/home/sutra/public_html/ /home/sutra/public_html.tmp/");
                    $ping = ob_get_clean();
                    if(stristr($ping, "total size is")){
                        echo "Перенос файлов " . PHP_EOL;
                        system("/home/daemon/classes/cp.sh");
                    }
                }
            } else {
                ob_start();
                system("ping -c 5 8.8.8.8");
                $ping = ob_get_clean();
                $ctx = stream_context_create(array('http' => array('timeout' => 30)));
                if((stristr($ping, "100% packet loss") || false === file_get_contents("http://8.8.8.8", false, $ctx)) && !file_exists(dirname(__FILE__) . '/../log/copy.pid')){
                    sleep(5);
                    ob_start();
                    system("ping -c 5 8.8.8.8");
                    $ping = ob_get_clean();
                    if((stristr($ping, "100% packet loss") || false === file_get_contents("http://8.8.8.8", false, $ctx)) && !file_exists(dirname(__FILE__) . '/../log/copy.pid')){
                        file_put_contents(dirname(__FILE__) . '/../log/copy.pid', 'lock');
                        mail("dev@yandex.ru", "SUTRA dedic erorr - move to backup", "SUTRA dedic erorr - move to backup");
                        mail("380971111111@sms.kyivstar.net", "SUTRA dedic erorr - move to backup", "SUTRA dedic erorr - move to backup");
                        echo "Сервер не доступен, переход на резервный" . PHP_EOL;
                        system("wget -O /dev/null https://dc-url-to-failover");
                        system("/etc/init.d/apache2 restart");
                    }
                }
            }
            exit();
        }
        return TRUE;
    }
    public function childSignalHandler($signo, $pid = null, $status = null) {
        switch($signo) {
            case SIGTERM:
                // При получении сигнала завершения работы устанавливаем флаг
                $this->stop_server = true;
                break;
            case SIGCHLD:
                // При получении сигнала от дочернего процесса
                if (!$pid) {
                    $pid = pcntl_waitpid(-1, $status, WNOHANG); 
                } 
                // Пока есть завершенные дочерние процессы
                while ($pid > 0) {
                    if ($pid && isset($this->currentJobs[$pid])) {
                        // Удаляем дочерние процессы из списка
                        unset($this->currentJobs[$pid]);
                    } 
                    $pid = pcntl_waitpid(-1, $status, WNOHANG);
                } 
                break;
            default:
                // все остальные сигналы
        }
    }
}
?>
